import type { ArkErrors } from "@ark/schema";
import type { inferred } from "@ark/util";
import type { GenericParser } from "../generic.ts";
import type { Module } from "../module.ts";
import { type Scope } from "../scope.ts";
import type { DeclarationParser, DefinitionParser, TypeParser } from "../type.ts";
import { arkBuiltin } from "./builtin.ts";
import { arkPrototypes } from "./constructors/constructors.ts";
import { number } from "./number/number.ts";
import { string } from "./string/string.ts";
import { arkTs } from "./ts.ts";
export interface Ark extends Omit<Ark.keywords, keyof Ark.Wrapped>, Ark.Wrapped {
}
export declare namespace Ark {
    interface keywords extends arkTs, arkPrototypes, arkBuiltin {
    }
    interface Wrapped {
        string: string.submodule;
        number: number.submodule;
    }
}
export declare const ambient: Scope<Ark>;
export declare const ark: Module<Ark>;
export declare const type: TypeParser<{}>;
export declare namespace type {
    type cast<t> = {
        [inferred]?: t;
    };
    type errors = ArkErrors;
}
export declare const generic: GenericParser<{}>;
export declare const define: DefinitionParser<{}>;
export declare const declare: DeclarationParser<{}>;
