import { rootNode } from "@ark/schema";
import { registry } from "@ark/util";
import { submodule } from "../utils.js";
export const FormDataModule = submodule({
    $root: ["instanceof", FormData],
    parse: rootNode({
        in: FormData,
        morphs: (data) => {
            const result = {};
            for (const [k, v] of data) {
                if (k in result) {
                    const existing = result[k];
                    if (typeof existing === "string" ||
                        existing instanceof registry.FileConstructor)
                        result[k] = [existing, v];
                    else
                        existing.push(v);
                }
                else
                    result[k] = v;
            }
            return result;
        }
    })
});
