import type { Module, Submodule } from "../../module.ts";
import { ArrayModule } from "./Array.ts";
import { FormDataModule } from "./FormData.ts";
import { TypedArray } from "./TypedArray.ts";
export declare const arkPrototypes: Module<arkPrototypes>;
export type arkPrototypes = arkPrototypes.submodule;
export declare namespace arkPrototypes {
    type submodule = Submodule<$>;
    interface $ extends Omit<ecmascript, keyof Wrapped>, platform, Wrapped {
    }
    interface Wrapped {
        Array: ArrayModule;
        TypedArray: TypedArray;
    }
    type ecmascript = {
        Array: Array<unknown>;
        Date: Date;
        Error: Error;
        Function: Function;
        Map: Map<unknown, unknown>;
        RegExp: RegExp;
        Set: Set<unknown>;
        WeakMap: WeakMap<object, unknown>;
        WeakSet: WeakSet<object>;
        Promise: Promise<unknown>;
    };
    type platform = {
        ArrayBuffer: ArrayBuffer;
        Blob: Blob;
        File: File;
        FormData: FormDataModule;
        Headers: Headers;
        Request: Request;
        Response: Response;
        URL: URL;
    };
    interface instances extends ecmascript, platform, TypedArray {
    }
    type instanceOf<name extends keyof instances = keyof instances> = instances[name];
    type instanceOfExcluding<name extends keyof instances = keyof instances> = instances[Exclude<keyof instances, name>];
}
