import { registry } from "@ark/util";
import { submodule } from "../utils.js";
import { ArrayModule } from "./Array.js";
import { FormDataModule } from "./FormData.js";
import { TypedArray } from "./TypedArray.js";
export const arkPrototypes = submodule({
    // ECMAScript Objects
    // See https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects
    Array: ArrayModule,
    Date: ["instanceof", Date],
    Error: ["instanceof", Error],
    Function: ["instanceof", Function],
    Map: ["instanceof", Map],
    RegExp: ["instanceof", RegExp],
    Set: ["instanceof", Set],
    WeakMap: ["instanceof", WeakMap],
    WeakSet: ["instanceof", WeakSet],
    Promise: ["instanceof", Promise],
    TypedArray,
    // Platform APIs
    // See https://developer.mozilla.org/en-US/docs/Web/API
    // Must be implemented in Node etc. as well as the browser to include here
    ArrayBuffer: ["instanceof", ArrayBuffer],
    Blob: ["instanceof", Blob],
    File: ["instanceof", registry.FileConstructor],
    FormData: FormDataModule,
    Headers: ["instanceof", Headers],
    Request: ["instanceof", Request],
    Response: ["instanceof", Response],
    URL: ["instanceof", URL]
});
