import type { Submodule } from "../../module.ts";
import type { Branded, constrain, To } from "../ast.ts";
declare namespace string {
    type normalized = normalized.NFC;
    namespace normalized {
        type NFC = constrain<string, Branded<"normalized.NFC">>;
        type NFD = constrain<string, Branded<"normalized.NFD">>;
        type NFKC = constrain<string, Branded<"normalized.NFKC">>;
        type NFKD = constrain<string, Branded<"normalized.NFKD">>;
    }
}
export declare const normalizedForms: readonly ["NFC", "NFD", "NFKC", "NFKD"];
export type NormalizedForm = (typeof normalizedForms)[number];
export type NFC = Submodule<{
    $root: (In: string) => To<string.normalized.NFC>;
    preformatted: string.normalized.NFC;
}>;
export declare const NFC: import("../../module.ts").Module<{
    $root: object;
    preformatted: object;
}>;
export type NFD = Submodule<{
    $root: (In: string) => To<string.normalized.NFD>;
    preformatted: string.normalized.NFD;
}>;
export declare const NFD: import("../../module.ts").Module<{
    $root: object;
    preformatted: object;
}>;
export type NFKC = Submodule<{
    $root: (In: string) => To<string.normalized.NFKC>;
    preformatted: string.normalized.NFKC;
}>;
export declare const NFKC: import("../../module.ts").Module<{
    $root: object;
    preformatted: object;
}>;
export type NFKD = Submodule<{
    $root: (In: string) => To<string.normalized.NFKD>;
    preformatted: string.normalized.NFKD;
}>;
export declare const NFKD: import("../../module.ts").Module<{
    $root: object;
    preformatted: object;
}>;
export declare const normalize: import("../../module.ts").Module<{
    $root: object;
    NFC: Submodule<{
        $root: object;
        preformatted: object;
    }>;
    NFD: Submodule<{
        $root: object;
        preformatted: object;
    }>;
    NFKC: Submodule<{
        $root: object;
        preformatted: object;
    }>;
    NFKD: Submodule<{
        $root: object;
        preformatted: object;
    }>;
}>;
export type normalize = Submodule<{
    $root: (In: string) => To<string.normalized.NFC>;
    NFC: NFC;
    NFD: NFD;
    NFKC: NFKC;
    NFKD: NFKD;
}>;
export {};
